/*!
  * Licensed Materials - Property of IBM
  * 5725N95, 5725P55, 5725N96
  * (C) Copyright IBM Corp. 1999, 2014.
  * US Government Users Restricted Rights- Use, duplication or disclosure
  * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

 /* $Id$ */
 
TreeController = 
{
	init : function()
	{
		var vc = ViewerController;
		vc.events.navigate.subscribe(this.handleNavigation,this,true);

		var root = vc.root;
		
		var t = this.tree = new YAHOO.widget.TreeView("tree_container");
		
		var leaf = vc.isLeaf(root);
		if (leaf)
		{
			this.addTreeNode(root,t.getRoot(),!leaf);
		}
		else
		{
			this.addTreeNodeChildren(root,t.getRoot(),true);
		}

		t.subscribe("clickEvent",TreeController.nodeClicked);
		//t.subscribe("expandComplete",TreeController.nodeExpanded);
		t.render();
		
		if (vc.current != null)
		{
			this.handleNavigation("navigation",[vc.current]);
		}
	},
	addTreeNode : function(obj, parentNode, addChildren)
	{
		if (obj.type != 1)
		{
			var n = new YAHOO.widget.TextNode({ label: obj.label, obj: obj, expanded:false, hasIcon:true }, parentNode);
			if (addChildren)
			{
				this.addTreeNodeChildren(obj,n,true);
			}
		}
	},
	addTreeNodeChildren : function(obj, parentNode, addChildren)
	{
		if (obj.children)
		{
			var c;
			for (var i=0; i<obj.children.length; i++)
			{
				c = obj.children[i];
				if (!ViewerController.isRemoved(c))
				{
					this.addTreeNode(obj.children[i], parentNode, true);
				}
			}
		}
	},
	handleNavigation : function(type, args)
	{
		var yd = YAHOO.util.Dom;
		var obj = args[0];
		
		if (this.current != null)
		{
			var last = this.tree.getNodeByProperty("obj",this.current);
			if (last != null)
			{
				yd.removeClass(last.getEl(),"activeNode");
			}
		}
		
		this.current = obj;

		var node = this.tree.getNodeByProperty("obj",obj);
		if (node != null)
		{
			var p = node;
			while ((p = p.parent) != null)
			{
				p.expand();
			}
			
			yd.addClass(node.getEl(),"activeNode");
		}
		else
		{
			this.tree.collapseAll();
		}
	},
	nodeClicked : function(e)
	{
		ViewerController.navigateTo(e.node.data.obj);
		return false;
	}
}

ProgressController = 
{
	current : -1,
	init : function()
	{
		$(".progressbar").progression({ 
				aBackground:"#2264C3", 
				Current:0, 
				Maximum: 100,
				Background: '#FFFFFF',
				TextColor: '#000000',
				aTextColor: '#FFFFFF',
				BorderColor: '#000000',
				Animate: true,
				AnimateTimeOut: 3000,
				Easing: 'linear' });
	
		var vc = ViewerController;
		vc.events.navigate.subscribe(this.update,this,true);
		vc.events.load.subscribe(this.update,this,true);
		vc.events.score.subscribe(this.update,this,true);

		if (vc.current != null)
		{
			this.update();
		}
	},
	update : function()
	{
		var p = ViewerController.getPosition();
		
		// only update if there is a change
		if (this.current != p.position)
		{
			document.getElementById("page_count").innerHTML = (p.position+1)+" of "+p.total;
			
			var c = Math.ceil((p.total > 0) ? ((ViewerController.getAccessedCount()/p.total)*100) : 0);
			
			$(".progressbar").progression({ Current:c });
		}
	}
}

ButtonController = 
{
	disableNext : false,
	init : function()
	{
		//this.prevLoButton = new YAHOO.widget.Button("btn_prev_lo", { name:"prev_lo", onclick:{ fn:function() { ViewerController.previousLO() } } }); 		
		//this.prevGroupButton = new YAHOO.widget.Button("btn_prev_group", { name:"prev_group", onclick:{ fn:function() { ViewerController.previous() } } }); 
		//this.nextGroupButton = new YAHOO.widget.Button("btn_next_group", { name:"next_group", onclick:{ fn:function() { ViewerController.next() }  } }); 
		//this.nextLoButton = new YAHOO.widget.Button("btn_next_lo", { name:"next_lo", onclick:{ fn:function() { ViewerController.nextLO() } } }); 
		
		
		this.prevLoButton = $( "#btn_prev_lo" ).button().click(function() { ViewerController.previousLO() });
		this.prevGroupButton = $( "#btn_prev_group" ).button().click(function() { ViewerController.previous() });
		this.nextGroupButton = $( "#btn_next_group" ).button().click(function() { ViewerController.next() });
		this.nextLoButton = $( "#btn_next_lo" ).button().click(function() { ViewerController.nextLO() });
		
		var vc = ViewerController;
		vc.events.navigate.subscribe(this.update,this,true);

		if (vc.current != null)
		{
			this.update();
		}
		
		if(this.disableNext){
			var cb = function()
			{
				this.disableNext = false;
				this.update();
				this.disableNext = true;
			}
			YAHOO.util.Event.addListener("groupFrame","load",cb,this,true);
		}
	},
	update : function()
	{ 
	$(this.prevGroupButton).addClass("yui-button");
	$(this.prevGroupButton).attr("disabled",!ViewerController.previous(true));
		//this.prevGroupButton.set("disabled",!ViewerController.previous(true));
	$(this.nextGroupButton).addClass("yui-button");
	$(this.nextGroupButton).attr("disabled",!ViewerController.previous(true));
		//this.nextGroupButton.set("disabled",!ViewerController.next(true));
	$(this.prevLoButton).addClass("yui-button");
	$(this.prevLoButton).attr("disabled",!ViewerController.previous(true));
		//this.prevLoButton.set("disabled",!ViewerController.previousLO(true));
	$(this.nextLoButton).addClass("yui-button");
	$(this.nextLoButton).attr("disabled",!ViewerController.previous(true));
		//this.nextLoButton.set("disabled",!ViewerController.nextLO(true));
		if(this.disableNext){
			//this.nextGroupButton.set("disabled",true);
			$(this.nextGroupButton).attr("disabled",true);
		}
	}
}

RichMediaController = 
{
		currentPlayers : null,
		isUnMute: true,
		volumeLevel: 50,
		init : function()
		{
			//this.playMediaButton = new YAHOO.widget.Button("btn_play", { name:"playMedia", onclick:{ fn:function() { RichMediaController.playMedia() } } }); 
			//this.pauseMediaButton = new YAHOO.widget.Button("btn_pause", { name:"pauseMedia", onclick:{ fn:function() { RichMediaController.pauseMedia() } } });
			//this.rewindMediaButton = new YAHOO.widget.Button("btn_rewind", { name:"rewindMedia", onclick:{ fn:function() { RichMediaController.rewindMedia() } } }); 
			//this.forwardMediaButton = new YAHOO.widget.Button("btn_forward", { name:"forwardMedia", onclick:{ fn:function() { RichMediaController.forwardMedia() } } });
			//this.unmuteMediaButton = new YAHOO.widget.Button("btn_unmute", { name:"unmuteMedia", onclick:{ fn:function() { RichMediaController.muteMedia() } } }); 
			//this.muteMediaButton = new YAHOO.widget.Button("btn_mute", { name:"muteMedia", onclick:{ fn:function() { RichMediaController.unmuteMedia() } } });
			//this.closeCaptionMediaButton = new YAHOO.widget.Button("btn_cc", { name:"closeCaptionMedia", onclick:{ fn:function() { RichMediaController.closeCaptionMedia() } } }); 
			//this.showCaptionMediaButton = new YAHOO.widget.Button("btn_sc", { name:"showCaptionMedia", onclick:{ fn:function() { RichMediaController.showCaptionMedia() } } });
			
			this.playMediaButton = $( "#btn_play" ).button().click(function() { RichMediaController.playMedia() });
			this.pauseMediaButton = $( "#btn_pause" ).button().click(function() { RichMediaController.pauseMedia() });
			this.rewindMediaButton = $( "#btn_rewind" ).button().click(function() { RichMediaController.rewindMedia() });
			this.forwardMediaButton = $( "#btn_forward" ).button().click(function() { RichMediaController.forwardMedia() });
			this.unmuteMediaButton = $( "#btn_unmute" ).button().click(function() { RichMediaController.muteMedia() });
			this.muteMediaButton = $( "#btn_mute" ).button().click(function() { RichMediaController.unmuteMedia() });
			this.closeCaptionMediaButton = $( "#btn_cc" ).button().click(function() { RichMediaController.closeCaptionMedia() });
			this.showCaptionMediaButton = $( "#btn_sc" ).button().click(function() { RichMediaController.showCaptionMedia() });
			
			$("#slider-volume").slider({	
				orientation: "horizontal",
				min: 0,
				max: 100,
				value: 50,
				slide: function(event, ui) {
					RichMediaController.volumeMedia(ui.value);
				}
			});
			
			var vc = ViewerController;			
			vc.events.media_loaded.subscribe(this.update,this,true);	
			this.updateButton(null);
		},	
		retakePlayer:function(player)
		{
			var frame = window.frames["groupFrame"];
			frame = (frame.contentWindow) ? frame.contentWindow : frame;
		    var o = frame.document.getElementsByClassName("objectouter")[0];   
		    if (o && o.nodeName == "OBJECT") { 
		    	player.setPlayerObj(o);
		        if (!player.validPlayerObj())
		        {
		            var n = o.getElementsByTagName("OBJECT")[0];          
		            if (n) {            	
		            	player.setPlayerObj(n);
		            }
		        }
		    }
		    return player;
		},
		rewindMedia:function()
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].rewind();
				//this.showPlayButton(true);
				
			}
		},
		forwardMedia:function()
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].forward();		
			}
		},
		pauseMedia: function()
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].pause();
				this.showPlayButton(true);			
			}
		},
		playMedia: function()
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].play();
				this.showPlayButton(false);			
			}
		},
		muteMedia: function()
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				for (var i=0; i<obj.length; i++)
				{
					if (!obj[i].validPlayerObj())
						obj[i] = this.retakePlayer(obj[i]);
					obj[i].mute();
				}
				
				this.showUnMuteButton(false);			
			}
		},
		unmuteMedia: function()
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].unmute();
				this.showUnMuteButton(true);		
			}
		},
		volumeMedia: function(value,changeSlide)
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].volume(value);	
				this.volumeLevel=value;
				//Unmute whenever volume level is adjusted
				if (changeSlide!=true) this.unmuteMedia();
			}
			
		},
		closeCaptionMedia: function()
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].hideCaptions();
				this.showCloseCaptionButton(false);		
			}
		},
		showCaptionMedia: function(value)
		{
			var obj = this.currentPlayers;
			if ((obj != null) && (obj.length>0))
			{
				if (!obj[0].validPlayerObj())
					obj[0] = this.retakePlayer(obj[0]);
				obj[0].showCaptions(value);		
				this.showCloseCaptionButton(true);		
			}
			
		},
		showPlayButton: function(b)
		{
			var yd = YAHOO.util.Dom;
			var playElm = yd.get("btn_play");
			var pauseElm = yd.get("btn_pause");
			var er = yd.getRegion(pauseElm);
			yd.setXY(playElm,[er.left,er.top]);
			if (b) 		{
				
				yd.get("btn_play").style.visibility='visible';
				yd.get("btn_pause").style.visibility='hidden';
			}
			else 
			{
				yd.get("btn_pause").style.visibility='visible';
				yd.get("btn_play").style.visibility='hidden';
			}
		},
		showUnMuteButton: function(b)
		{
			var yd = YAHOO.util.Dom;
			var unmuteElm = yd.get("btn_unmute");
			var muteElm = yd.get("btn_mute");
			var er = yd.getRegion(muteElm);
			yd.setXY(unmuteElm,[er.left,er.top]);
			if (b) 		{
				
				yd.get("btn_unmute").style.visibility='visible';
				yd.get("btn_mute").style.visibility='hidden';
			}
			else 
			{
				yd.get("btn_mute").style.visibility='visible';
				yd.get("btn_unmute").style.visibility='hidden';
			}
			this.isUnMute=b;
		},
		showCloseCaptionButton: function(b)
		{
			var yd = YAHOO.util.Dom;
			var closeCaptionElm = yd.get("btn_cc");
			var showCaptionElm = yd.get("btn_sc");
			var er = yd.getRegion(showCaptionElm);
			yd.setXY(closeCaptionElm,[er.left,er.top]);
			if (b) 		{
				
				yd.get("btn_cc").style.visibility='visible';
				yd.get("btn_sc").style.visibility='hidden';
			}
			else 
			{
				yd.get("btn_sc").style.visibility='visible';
				yd.get("btn_cc").style.visibility='hidden';
			}
		},			
		update:function(type, args)
		{
			var obj = args[0];
			this.currentPlayers = obj;
			this.updateButton(obj);
		},	
		updateButton:function(obj)
		{
			//Tam Le change for #40466
			//this.showUnMuteButton(true);
			this.volumeMedia(this.volumeLevel,true);
			
			this.showUnMuteButton(this.isUnMute);
			if (this.isUnMute==true) this.unmuteMedia();
			else this.muteMedia();
			
			this.showCloseCaptionButton(true);
						
			if ((obj != null) && (obj.length>0))
			{							
				this.showPlayButton(!obj[0].autoplay);
				this.showCloseCaptionButton(!obj[0].isClosedCaption);
				this.enableButton(obj[0], false);				
			}
			else
			{
				this.showPlayButton(true);
				this.enableButton(obj, true);
			}
		},
		enableButton:function(obj, enabled){		
			//this.playMediaButton.set("disabled",enabled || !obj.settings.play);
			//this.pauseMediaButton.set("disabled",enabled || !obj.settings.pause);
			//this.rewindMediaButton.set("disabled",enabled || !obj.settings.rewind);
			//this.forwardMediaButton.set("disabled",enabled || !obj.settings.forward);
			//this.closeCaptionMediaButton.set("disabled",enabled || !obj.settings.hideCaptions);
			//this.showCaptionMediaButton.set("disabled",enabled || !obj.settings.showCaptions);	
			//this.unmuteMediaButton.set("disabled",enabled || !obj.settings.unmute);
			//this.muteMediaButton.set("disabled",enabled || !obj.settings.mute);	
			
		$(this.playMediaButton).addClass("yui-button");
		$(this.playMediaButton).attr("disabled",enabled);
		$(this.pauseMediaButton).addClass("yui-button");
		$(this.pauseMediaButton).attr("disabled",enabled);
		$(this.rewindMediaButton).addClass("yui-button");
		$(this.rewindMediaButton).attr("disabled",enabled);
		$(this.forwardMediaButton).addClass("yui-button");
		$(this.forwardMediaButton).attr("disabled",enabled);
		$(this.closeCaptionMediaButton).addClass("yui-button");
		$(this.closeCaptionMediaButton).attr("disabled",enabled);
		$(this.showCaptionMediaButton).addClass("yui-button");
		$(this.showCaptionMediaButton).attr("disabled",enabled);	
		$(this.unmuteMediaButton).addClass("yui-button");
		$(this.unmuteMediaButton).attr("disabled",enabled);
		$(this.muteMediaButton).addClass("yui-button");
		$(this.muteMediaButton).attr("disabled",enabled);
			
			
			$("#slider-volume").slider( "option", "disabled", enabled || !obj.settings.volume );
			$("#slider-volume").filter('[aria-disabled="true"]').removeClass("ui-state-disabled").addClass("mui-state-disabled");						
			$("#slider-volume").filter('[aria-disabled="false"]').removeClass("mui-state-disabled");			
		}	
}	

BreadCrumbController = 
{
	init : function()
	{
		var vc = ViewerController;
		vc.events.navigate.subscribe(this.update,this,true);

		if (vc.current != null)
		{
			this.update("navigation",[vc.current]);
		}
	},
	update : function(type,args)
	{
		var yd = YAHOO.util.Dom;
		var obj = args[0];
		
		var cfg = ["root_label","lo_label","group_label"];
		for (var i=0; i<cfg.length; i++)
		{
			yd.get(cfg[i]).innerHTML = "";
		}
		
		var pMap = {};
		var p = obj;
		while ((p = p.parent) != null)
		{
			pMap[p.type] = p;
		}
		
		if (!obj.parent)
		{
			yd.get("root_label").innerHTML = obj.label;
		}
		else if (obj.parent.type == 5)
		{
			yd.get("root_label").innerHTML = obj.parent.label;
			yd.get("lo_label").innerHTML = obj.label;
		}
		else if (obj.parent.type == 4)
		{
			if (pMap[5])
			{
				yd.get("root_label").innerHTML = pMap[5].label;
				yd.get("lo_label").innerHTML = obj.parent.label;
				yd.get("group_label").innerHTML = obj.label;
			}
			else
			{
				yd.get("root_label").innerHTML = obj.parent.label;
				yd.get("group_label").innerHTML = obj.label;
			}
		}
		else if (obj.parent.type == 3)
		{
			if (pMap[5])
			{
				yd.get("root_label").innerHTML = pMap[5].label;
				yd.get("lo_label").innerHTML = obj.parent.label;
				yd.get("group_label").innerHTML = obj.label;
			}
			else if (pMap[4])
			{
				yd.get("root_label").innerHTML = pMap[4].label;
				yd.get("lo_label").innerHTML = obj.parent.label;
				yd.get("group_label").innerHTML = obj.label;
			}
			else
			{
				yd.get("root_label").innerHTML = obj.parent.label;
				yd.get("group_label").innerHTML = obj.label;
			}
		}
		else if (obj.parent.type == 2)
		{
			if (pMap[5])
			{
				yd.get("root_label").innerHTML = pMap[5].label;
				yd.get("lo_label").innerHTML = pMap[3].label;
				yd.get("group_label").innerHTML = obj.label;
			}
			else if (pMap[4])
			{
				yd.get("root_label").innerHTML = pMap[4].label;
				yd.get("lo_label").innerHTML = pMap[3].label;
				yd.get("group_label").innerHTML = obj.label;
			}
			else if (pMap[3])
			{
				yd.get("root_label").innerHTML = pMap[3].label;
				yd.get("group_label").innerHTML = obj.label;
			}
			else
			{
				yd.get("root_label").innerHTML = obj.parent.label;
				yd.get("group_label").innerHTML = obj.label;
			}
		}
	}
}